

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.23. index_column_diff &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.3.24. io_flush" href="io_flush.html" />
    <link rel="prev" title="7.3.22. dump" href="dump.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/commands/index_column_diff.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="io_flush.html" title="7.3.24. io_flush"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="dump.html" title="7.3.22. dump"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>コマンド</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.23. </span><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="index-column-diff">
<h1><span class="section-number">7.3.23. </span><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code><a class="headerlink" href="#index-column-diff" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.23.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 9.0.1 で追加.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code> コマンドはインデックスが破損しているかどうかをチェックします。</p>
<p>このコマンドによって、既に破損したインデックスを発見できます。通常、壊れたインデックスはGroongaが参照や削除、更新をしない限り発見できません。壊れたインデックスを使うとGroongaがクラッシュしたり、誤った検索結果を返すことがあります。そのため、事前にインデックスの破損を発見したくなります。このコマンドはこのようなケースで有用です。</p>
<div class="admonition note">
<p class="admonition-title">注釈</p>
<p>このコマンドは、対象のインデックスのサイズによっては、多くのメモリーや実行時間を使うことがあります。また、このコマンドを実行中に停止した場合は、対象のインデックスが壊れることがあります。そのため、現用系のシステムで実行するのではなく、予備系のシステムで実行することをおすすめします。</p>
</div>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.23.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このコマンドの引数は2つで必須です。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>index_column_diff table index_column
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.23.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>以下はインデックスカラムをチェックする例です。:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Data TABLE_HASH_KEY ShortText
# [[0,1612416118.30525,0.003424882888793945],true]
table_create Terms TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenNgram \
  --normalizer NormalizerNFKC130
# [[0,1612416136.049046,0.003507614135742188],true]
load --table Data
[
{&quot;_key&quot;: &quot;Hello World&quot;},
{&quot;_key&quot;: &quot;Hello Groonga&quot;}
]
# [[0,1612416155.418526,0.3676469326019287],2]
column_create \
  --table Terms \
  --name data_index \
  --flags COLUMN_INDEX|WITH_POSITION \
  --type Data \
  --source _key
# [[0,1612416424.515037,0.00576472282409668],true]
truncate Terms.data_index
# [[0,1612416439.925894,0.009646892547607422],true]
load --table Data
[
{&quot;_key&quot;: &quot;Good-by World&quot;},
{&quot;_key&quot;: &quot;Good-by Groonga&quot;}
]
# [[0,1612416450.429434,1.51789665222168],2]
index_column_diff Terms data_index
# [
#   [
#     0,
#     1612416577.921113,
#     0.006278038024902344
#   ],
#   [
#     {
#       &quot;token&quot;: {
#         &quot;id&quot;: 2,
#         &quot;value&quot;: &quot;hello&quot;
#       },
#       &quot;remains&quot;: [
#       ],
#       &quot;missings&quot;: [
#         {
#           &quot;record_id&quot;: 1,
#           &quot;position&quot;: 0
#         },
#         {
#           &quot;record_id&quot;: 2,
#           &quot;position&quot;: 0
#         }
#       ]
#     },
#     {
#       &quot;token&quot;: {
#         &quot;id&quot;: 3,
#         &quot;value&quot;: &quot;world&quot;
#       },
#       &quot;remains&quot;: [
#       ],
#       &quot;missings&quot;: [
#         {
#           &quot;record_id&quot;: 1,
#           &quot;position&quot;: 1
#         }
#       ]
#     },
#     {
#       &quot;token&quot;: {
#         &quot;id&quot;: 1,
#         &quot;value&quot;: &quot;groonga&quot;
#       },
#       &quot;remains&quot;: [
#       ],
#       &quot;missings&quot;: [
#         {
#           &quot;record_id&quot;: 2,
#           &quot;position&quot;: 1
#         }
#       ]
#     }
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.23.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このセクションではすべての引数について説明します。</p>
<div class="section" id="table">
<h3><span class="section-number">7.3.23.4.1. </span><code class="docutils literal notranslate"><span class="pre">table</span></code><a class="headerlink" href="#table" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>チェックするインデックスカラムを含むテーブルの名前を指定します。</p>
</div>
<div class="section" id="index-column">
<h3><span class="section-number">7.3.23.4.2. </span><code class="docutils literal notranslate"><span class="pre">index_column</span></code><a class="headerlink" href="#index-column" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>チェック対象のインデックスカラムの名前を指定します。</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.23.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code> コマンドはインデックスチェックの結果を返します。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, CHECK_RESULT]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code></p>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code> については <a class="reference internal" href="../command/output_format.html"><span class="doc">出力形式</span></a> を参照してください。</p>
<p><code class="docutils literal notranslate"><span class="pre">CHECK_RESULT</span></code></p>
<p>このコマンドは、以下のように、このコマンドを実行した時のトークナイズの結果と、現在のインデックスカラムの値を比較した結果を返します。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>{
  &quot;token&quot;: {
    &quot;id&quot;: TOKEN_ID,
    &quot;value&quot;: TOKEN_VALUE
  },
  &quot;remains&quot;: [
    {
      &quot;record_id&quot;: RECORD_ID
    }
  ],
  &quot;missings&quot;: [
    {
      &quot;record_id&quot;: RECORD_ID,
      &quot;position&quot;: POSITION
    }
  ]
}
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">remains</span></code> になにか出力された場合、Groongaが本来削除するはずだったトークンがインデックスが残っています。</p>
<p><code class="docutils literal notranslate"><span class="pre">missing</span></code> になにか出力された場合、本来インデックス内に残っているトークンが削除されています。</p>
<p>インデックスの破損が無い時は、以下のように <code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code> は何も返しません。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>index_column_diff --table table --name index_column
[[0,0.0,0.0],[]]
</pre></div>
</div>
<div class="section" id="token-id">
<h3><span class="section-number">7.3.23.5.1. </span><code class="docutils literal notranslate"><span class="pre">TOKEN_ID</span></code><a class="headerlink" href="#token-id" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">TOKEN_ID</span></code> は壊れたトークンのIDです。</p>
</div>
<div class="section" id="token-value">
<h3><span class="section-number">7.3.23.5.2. </span><code class="docutils literal notranslate"><span class="pre">TOKEN_VALUE</span></code><a class="headerlink" href="#token-value" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">TOKEN_VALUE</span></code> は壊れたトークンの値です。</p>
</div>
<div class="section" id="record-id">
<h3><span class="section-number">7.3.23.5.3. </span><code class="docutils literal notranslate"><span class="pre">RECORD_ID</span></code><a class="headerlink" href="#record-id" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">RECORD_ID</span></code> は壊れたトークンを含むレコードです。</p>
</div>
<div class="section" id="position">
<h3><span class="section-number">7.3.23.5.4. </span><code class="docutils literal notranslate"><span class="pre">POSITION</span></code><a class="headerlink" href="#position" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">POSITION</span></code> 壊れたトークンの出現位置です。</p>
</div>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.23. <code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.23.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.3.23.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.3.23.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.3.23.4. 引数</a><ul>
<li><a class="reference internal" href="#table">7.3.23.4.1. <code class="docutils literal notranslate"><span class="pre">table</span></code></a></li>
<li><a class="reference internal" href="#index-column">7.3.23.4.2. <code class="docutils literal notranslate"><span class="pre">index_column</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.23.5. 戻り値</a><ul>
<li><a class="reference internal" href="#token-id">7.3.23.5.1. <code class="docutils literal notranslate"><span class="pre">TOKEN_ID</span></code></a></li>
<li><a class="reference internal" href="#token-value">7.3.23.5.2. <code class="docutils literal notranslate"><span class="pre">TOKEN_VALUE</span></code></a></li>
<li><a class="reference internal" href="#record-id">7.3.23.5.3. <code class="docutils literal notranslate"><span class="pre">RECORD_ID</span></code></a></li>
<li><a class="reference internal" href="#position">7.3.23.5.4. <code class="docutils literal notranslate"><span class="pre">POSITION</span></code></a></li>
</ul>
</li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="dump.html"
                        title="前の章へ"><span class="section-number">7.3.22. </span><code class="docutils literal notranslate"><span class="pre">dump</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="io_flush.html"
                        title="次の章へ"><span class="section-number">7.3.24. </span><code class="docutils literal notranslate"><span class="pre">io_flush</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="io_flush.html" title="7.3.24. io_flush"
             >次へ</a> |</li>
        <li class="right" >
          <a href="dump.html" title="7.3.22. dump"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>コマンド</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.23. </span><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>